// C Source File
// Created 11/01/2004; 17:26:31

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.01 or higher

//#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
//#include "preproc.h"

#define getuc ((*(fonc[*(argptr)]))()).uc
#define getui ((*(fonc[*(argptr)]))()).ui
#define getul ((*(fonc[*(argptr)]))()).ul
#define getsc ((*(fonc[*(argptr)]))()).sc
#define getsi ((*(fonc[*(argptr)]))()).si
#define getsl ((*(fonc[*(argptr)]))()).sl
#define getpuc ((*(fonc[*(argptr)]))()).puc
#define getpui ((*(fonc[*(argptr)]))()).pui
#define getpul ((*(fonc[*(argptr)]))()).pul
#define getpsc ((*(fonc[*(argptr)]))()).psc
#define getpsi ((*(fonc[*(argptr)]))()).psi
#define getpsl ((*(fonc[*(argptr)]))()).psl
#define geth		((*(fonc[*(argptr)]))()).h
#define getpfile		((*(fonc[*(argptr)]))()).pfile
#define rul return (ans)(unsigned long)
#define rsl return (ans)(signed long)
#define rui return (ans)(unsigned int)
#define rsi return (ans)(signed int)
#define ruc return (ans)(unsigned char)
#define rsc return (ans)(signed char)
#define rpul return (ans)(unsigned long*)
#define rpsl return (ans)(signed long*)
#define rpui return (ans)(unsigned int*)
#define rpsi return (ans)(signed int*)
#define rpuc return (ans)(unsigned char*)
#define rpsc return (ans)(signed char*)
#define resi return (ans)(ESI)
#define rh return (ans)(h)
#define rpfile return (ans)(FILE*)
//#define rpans return (ans)(ans*)


INT_HANDLER OldInt5 = NULL;
INT_HANDLER save_int_1;

volatile int Counter = 0;


unsigned int srcsize,nintr,sintr;
unsigned char *srcptr,*ptr,brkvar,iintr,inc,int5_allowed,sv_scr_on,*screen_buffer;
long condswitch[5],rtnf[30],argin[30]; //retour des fonctions inlines : imbrication max de 30 appels . Entre fonction inline
unsigned char i_rtnf,i_intr,byte_width_ilist[256];
FILE *fp;
HANDLE handle;
ESI argptr,argdep,argintr[21],speedintr[21],intrdeb,argfunc[30],argendfunc[30],arglbl[256],argwhile[30],argendwhile[30]/*,argfor[100],argendfor[30]*/,argelse[257],argendif[257],argloop[30];
void *kbq;		//For the function gkey()

							//0				1					2					3					4					5					6					7					8					9


unsigned char
 *foncs[]={		""		,"GUCHAR"	,	"GSLVAR","adress"	,		"FLBL",	"FGOTO"	,"keywait",		"isz"	,		"dsz"	,		"iff"	, //0
						"freeh"	,	"endh"	,	"exech"	,		""		,	"INDIR"	,"printf1","printf2",	""			,"prints",	"elsee"	, //1
					"svscroff","fedwhil",	"finish",	"ifs"		,		""		,	"printc","sprintf",	"chars"	,	"strcat",	""			, //2
							""		,"GUINT"	,		""		,		""		,		""		,"printld","printxy",		""		,"GULONG"	,	"inter"	, //3
						"dline"	,"dmline"	,	"gmode"	,"sprt8"	,"sprt16"	,		""		,	"code"	,"interoff","interon",		""		, //4
						"setlcd",	"dpix"	,"gpix"		,"sprt32","fillrect","clrlcd"	,"keytest","int1off","int1on" ,"ifthen"	, //5
						"getlcd",	"fwhile",		""		,		""		,		""		,		""		,		""		,"int5off","int5on" ,	"elsee"	, //6
					"grayon"	,"grayoff","light"	,	"dark"	,		""		,"drawstr","setfont","freet"	,"settimer",	"endiff", //7
					"gotopos"	,	"pos"		,		"jsr" ,	"rts"		,		"fonc",		""		,		""		,"timerexp","timerval",		""		, //8
					"lscroll"	,"rscroll","uscroll","bscroll",		"lrol",	"rrol"	,		""		,  "idle" ,	"memcpy",		""		, //9
						"clrscr","X rand" ,	"gsprt","lscroll2","rscroll2","uscroll2","bscroll2",""		,"memmove",		""		, //10
						"fopen"	,	"fclose",	"fputc"	,	"fgets"	,	"fgetc"	,	"fputs"	,		""		,	"gets"	,		""		,		""		, //11
							"nott",		""		,		"neg"	,		""		,		""		,		""		,		""		,		""		,		"sto"	,		""		, //12
							"xorr",		"orr"	,		"andd",		"inf"	,	"infeq"	,		"eq"	,	"supeq"	,	"sup"		,	"noteq"	,		"add", //13
							""		,		"sub"	,		""		,		"mul"	,		""		,		"div"	,		""		,		""		,		"up"	,	"second", //14
							"def"	,	"enddef",		""		,		"fc"	,		"arg"	,		"rtn"	,	"group"	,		""		,		"down",	"shiftt", //15
						"repeat",		""		,"savescr","loadscr",		""		,		"lb"	,		"lw"	,		"ll"	,		"leftt","diamond", //16
							""		,	"os"		,		"toos",		""		,		""		,		"wb"	,		"ww"	,		"wl"	,	"rightt",	"alpha"	, //17
							""		,		""		,	"gkey" ,"keydelay",		""		,		""		,		""		,		""		,		""		,		""		, //18
					"pokeb"		,	"pokew"	,	"pokel"	,		""		,		""		,		""		,		""		,		""		,		""		,		""		, //19
					"peekb"		,	"peekw"	,	"peekl"	,		""		,		""		,		""		,		""		,		""		,		""		,		""		, //20
							""		,		""		,		""	, "xxllelem",		""		,		""		,"nilist"	,	"mklist",		""		,		""		, //21
							"map"	,	"multi"	,		"two"	,		""		,		""		,		""		,		""		,		""		,		""		,"ENDTAG"	, //22
							""		,		""		,		""		,	"finish",		""		,	"ctup"	,	"ctdown",		""		,		""		,		""		, //23
					"debugon"	,"debugoff",		""		,	""		,		""		,		""		,		""		,		""		,"execbas",		""		, //24
							"nop"	,	"malloc",		"free","memset"	,		""		,"asmcall",		""		,		""		,		""		,	"enddef"}; //25


typedef union 
  {
    unsigned char uc;
    unsigned int ui;
    unsigned long ul;
    signed char sc;
    signed int si;
    signed long sl;
    unsigned char *puc;
    unsigned int *pui;
    unsigned long *pul;
    signed char *psc;
    signed int *psi;
    signed long *psl;
    HANDLE h;
    ESI esi;
    FILE *pfile;
    //ans *pans;
  } ans;

typedef struct 
{
	char *fptr, *cptr;
	unsigned short plen;
  HANDLE h;
} File ;

SCR_RECT scr_rect;
char nsubfonc,gmode,nswitch;		//gmode = mode graphique & or xor etc...
char strchars[2];
void *lcdad;
ans varlist[256];
ESI lbl[256];
ESI subfonc[20];
ans (*fonc[])(void);
long *scr_copy[3];
unsigned char mod_uchar(unsigned char a, unsigned char b)
{
	if(b==0) return a;
	else return a%b;
}
DEFINE_INT_HANDLER(MyInt5)
{
  unsigned char i,tempp;
  inc++;
  //printf(" inc=%d",inc);
  intrdeb=argptr;
	for(i=0;i<20;i++)
	{
		//if(!(inc%(speedintr[i])))
		//if(argintr[i]==0 || speedintr[i]==0) continue;
		tempp=speedintr[i];
		if(tempp==0) tempp=inc;
		else tempp=(inc%tempp);
		//tempp=mod_uchar(inc,speedintr[i]);
		if(tempp==0 && speedintr[i]!=0)
		{
			//printf("tempp=%d",tempp);
			argptr=argintr[i]; //on pointe maintenant sur le tag de la nilist a excuter
			//printf(" inc=%d",inc);
			argptr++;
			sintr=getsl;
			nintr=getsl;
			for(iintr=0;iintr<nintr;iintr++)	//Excute les instructions de l'interruption (de la nilist)
			{
				(*(fonc[*(argptr)]))();
				//getsl;
			}
		}
	}
  if(int5_allowed) ExecuteHandler (OldInt5);
  argptr=intrdeb;
}


void exec_none_stop(void)
{
	//Before : while(*argptr!=0xE9)
	while(1)
	{
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
		(*(fonc[*(argptr)]))();
	}
}
void skip_str(void)	//argptr doit point sur le prem char de la string
{
	while(*(argptr)!=0) argptr++;
	argptr++;
}
ESI foundarg(unsigned char val)
{
	ESI argptrori,argptrf;;
	argptrori=argptr;
	while(*argptr!=val)
	{
		if(*argptr==0xE9) { return NULL; }
		skip_arg();
		/*if(*argptr==STR_TAG) skip_str();
		else 
		{
			if(*argptr==1 || *argptr==POSINT_TAG || *argptr==NEGINT_TAG || *argptr==IM_TAG || *argptr==2) getsl;
			else
			{
				if(*argptr==0xE9) { argptr=argptrori; return argptrori; }
				argptr++;
			}
		}*/
	}
	argptrf=argptr;
	argptr=argptrori;
	return argptrf;
}
void skip_arg(void)
{
	if(*argptr==STR_TAG) skip_str();
		else 
		{
			if(*argptr==1 || *argptr==POSINT_TAG || *argptr==NEGINT_TAG || *argptr==IM_TAG || *argptr==2) getsl;
			else
			{
				if(*argptr==0xE9) { return; }
				argptr++;
			}
		}
}
void init_bkm(void)
{
	ESI argptrori;
	int cmd,var,i;
	for(i=0;i<=256;i++) argelse[i]=NULL;	//Initialise les else (utile car ils ne sont pas obligatoires)
	argptrori=argptr;
	cmd=*argptr;
	while(cmd!=0xE9)
	{
		switch(cmd)
		{
			case 24:			//LOOP
			argptr++;
			var=*(argptr+1);
			argloop[var]=argptr+2;
			break;
			case 34:			//ENDLOOP
			argptr++;
			
			break;
			case 0x04:	//label
			argptr++;
			var=*(argptr+1);
			arglbl[var]=argptr+2;
			break;
			case 0x3D:	//while
			argptr++;
			var=*(argptr+1);
			argwhile[var]=argptr-1;	//pointe sur le dbut de while pour tester la condition
			break;
			case 0x15:	//endwhile
			argptr++;
			var=*(argptr+1);
			argendwhile[var]=argptr+2;
			break;
			case 0x74:	//	FOR			"for varna,strt,end,s"
			argptr++;
			//var=*(argptr+1);   EST initialis directement dans la fonction
			//argfor[var]=argptr-1;
			break;
			/*case 0x0E:		//ENDFOR are not implemented Yet because of a bug
			argptr++;
			var=*(argptr+1);
			argendfor[var]=argptr+2;
			break;*/
			
			case 0x45:	//else
			argptr++;
			var=*(argptr+1);
			//printf("var else=%d",var);
			/*if(*(argptr+2)==0x4F && *(argptr+4)==var)	//Si il est suivi de son endif, alors on passe le endif(optimisation)
			{
				argelse[var]=argptr+5;
			}*/
			/*else*/ argelse[var]=argptr+2;
			break;
			case 0x4F:	//endif
			argptr++;
			var=*(argptr+1);
			//if(argelse[var]==NULL) argelse[var]=argptr+2-3;
			//printf("var endif=%d",var);
			if(argelse[var]==NULL) argelse[var]=argptr+2;
			argendif[var]=argptr+2;
			break;
		}
		skip_arg();
		cmd=*argptr;
		//printf(" %x",cmd);
	}
  argptr=argptrori;
}	

typedef struct 
{
	char *fptr, *cptr;
	unsigned short plen;
  HANDLE h;
} Files ;

HANDLE CreateFile (const char *FileName)
// Returns a handle, H_NULL in case of error
{
  HANDLE h;
  SYM_ENTRY *sym_entry;
  char str[30], *sptr = str;
  *sptr = 0; while ((*++sptr = *FileName++));
  if (!(h = HeapAlloc (HeapMax ()))) return H_NULL;
  if (!(sym_entry = DerefSym (SymAdd (sptr))))
    {
      HeapFree (h);
      return H_NULL;
    }
  *(long*) HeapDeref (sym_entry->handle = h) = 0x00010000;
  return h;
}
Files* OpenFile(const char *FileName)
{
	char *fptr, *cptr;
	unsigned short plen;
	SYM_ENTRY *SymPtr;
	HANDLE h;
	
	Files *fileptr;
	
	SymPtr = DerefSym (SymFind (SYMSTR (FileName)));
	if (!SymPtr) {/*fatal ("Program not found");*/ return 0;}
	h = SymPtr->handle;
  if (HeapGetLock (h))
    {
      cptr = fptr = HeapDeref (h);
      h = 0;
    }
  else
    {
      cptr = fptr = HLock (h);
    }
  plen = *(short*)(cptr) + 3;
  if (SymPtr->flags.bits.archived)
    {
      if (!(cptr = malloc (plen)))
        {
          if (h) HeapUnlock (h);
          exit2 ("Out of memory");
        }
      memcpy (cptr, fptr, plen);
    }
    
    //Create a struct of type file
	if(!(fileptr=malloc(sizeof(Files))))
  	{
  		if (h) HeapUnlock (h);
  		if (cptr != fptr) free (cptr);
  		exit2("Memory error");
  	}
  	
  fileptr->fptr=fptr;
  fileptr->cptr=cptr;
  fileptr->plen=plen;
  fileptr->h=h;
  	
  return fileptr;
}
void CloseOpenedFile(Files *fileptr)
{
	if (fileptr->h) HeapUnlock (fileptr->h);
  if (fileptr->cptr != fileptr->fptr) free (fileptr->cptr);
  if(fileptr) free(fileptr);
}

void AppendCharToFile (HANDLE h, unsigned char c)
{
  char *base = HeapDeref(h);
  unsigned short len = *(unsigned short*)base;
  if (len > HeapSize(h) - 10) return;
  *(unsigned short*)base = len + 1;
  base[len+2] = c;
}

void AppendBlockToFile (HANDLE h, void *addr, unsigned short len)
{
  unsigned short i;
  for (i = len; i; i--) AppendCharToFile (h, *((char*)addr)++);
}

void CloseFile (HANDLE h)
{
  AppendCharToFile (h,0); AppendCharToFile (h,0x2D);
  HeapUnlock (h);
  HeapRealloc (h, *(unsigned short*)HeapDeref(h) + 3);
}
void CloseFile_type (HANDLE h,int type)
{
  if(type==STR_TAG) AppendCharToFile (h,0);
  AppendCharToFile (h,type);
  HeapUnlock (h);
  HeapRealloc (h, *(unsigned short*)HeapDeref(h) + 3);
}
void AppendStrToFile (HANDLE handle, void *str)
{
	AppendBlockToFile (handle, str, strlen(str));
}

ans guchar(void)
{
	argptr+=2;
	rul(*(argptr-1));
	//return (ans)(*(argptr-1));
}
ans gchar(void)
{
	argptr+=2;
	rsl(*(argptr-1));
	//return (ans)(*(argptr-1));
}
ans guint(void)
{
	unsigned int ui;
	unsigned char *p;
	p=&ui;
	*p=*(argptr+1); *(p+1)=*(argptr+2);
	argptr+=3;
	rul(ui);
}
ans gint(void)
{
	int vi;
	unsigned char *p;
	p=&vi;
	*p=*(argptr+1); *(p+1)=*(argptr+2);
	argptr+=3;
	rsl(vi);
}
ans gulong(void)
{
	unsigned long ul;
	unsigned char *p;
	p=&ul;
	*p=*(argptr+1); *(p+1)=*(argptr+2); *(p+2)=*(argptr+3); *(p+3)=*(argptr+4);
	argptr+=5;
	rul(ul);
	//return (ans)(ul);
}
ans glong(void)
{
	signed long ul;
	unsigned char *p;
	p=&ul;
	*p=*(argptr+1); *(p+1)=*(argptr+2); *(p+2)=*(argptr+3); *(p+3)=*(argptr+4);
	argptr+=5;
	rsl(ul);
	//return (ans)(ul);
}
ans execbas(void) //pas tres rapide
{
	ESI arg;
	HANDLE handle;																					//HEXA:F8 IP1 IP2 DATA
	delete_between (bottom_estack, top_estack); 
	for(arg=argptr+3;arg<argptr+3+*(argptr+2);arg++)
		{
			push_quantum (*arg);
		}
		if((handle = HS_popEStack ())==NULL) exit2("hspop err");
	NG_execute (handle, FALSE);
	HeapFree (handle);
	argptr=arg;
	return (ans)0;
}
void exec_cmd(unsigned char *cmd)
{
	//int ans;
	HANDLE handle;
	push_parse_text (cmd);
	handle = HS_popEStack ();
  NG_execute (handle, FALSE);
	HeapFree (handle);
	//ans = GetIntArg (top_estack);
}
ans clscr(void)
{
	clrscr();
	argptr++;
}
//(*(fonc[*(argptr)]))();
ans a(void)
{
	printf("\n=========>*arg=%x &=%x",*argptr,(int)(argptr-argdep+2)); ngetchx();
	exit2("exit by unknown fonc");
	return (ans)0;
}
ans lusfunc(void)
{
	argptr+=1;
	//printf("\nexec:%s",foncs[*argptr]);
	//rsl((*(fonc[*(argptr)])()).sl);
	//return (ans)0;
}
ans gstr(void)
{
	unsigned int dim;
	unsigned char *p;
	argptr+=1;
	dim=getul;
	p=argptr;
	argptr+=dim+1;
	rpuc(p);
}
ans gpvar(void)
{
	argptr+=2;
	rpul(&(varlist[*(argptr-1)]));
}
ans neg(void) //correspond au minus_tag
{
	argptr++;
	rsl(-(getul));
}
ans gslvar(void)		//equivalent  rsl(*ptrvar)
{
	argptr+=2;
	rsl((varlist[*(argptr-1)]).sl);
}
ans printf1(void)
{
	unsigned char *s;
	argptr+=1;
	s=getpuc;
	printf(s,getsl);
	rpuc(s);
}
ans printf2(void)
{
	unsigned char *s;
	long vaaa,vbbb;
	argptr+=1;
	s=getpuc;
	vaaa=getsl;
	vbbb=getsl;
	//printf("\n%lp",&varlist);
	printf(s,vaaa,vbbb);
	rpuc(s);
}
ans sto(void)
{
	char nvarr;
	long f;
	unsigned int elem_index;
	argptr++;
/*	if(*argptr==0x02)	//gslvar tag
	{
		argptr+=2;	//point to the value to store
		varlist[*(argptr-1)]=(ans)(f=getsl);
		rsl(f);
	}
	else	//ca ne peut etre qu'une string
	{
		argptr+=2;		//point to the value to store
		varlist[*(argptr-1)]=(ans)(f=getpuc);
		rsl(f);
	}
*/
	switch(*argptr)
	{
		case 0x02: //gslvar tag. The destination is a var
		argptr+=2;	//point to the value to store
		nvarr=*(argptr-1);
		//printf("dim elem array%d",byte_width_ilist[nvarr]); //ngetchx();
		f=getsl;
		varlist[nvarr].sl=f;
		rsl(f);
		break;
		case SUBSCRIPT_TAG:	//the destination in an element of a list
		argptr+=3;
		nvarr=*(argptr-1);	//number of the list/var
		elem_index=getsl;		//elem_index of the list
		f=getsl;		//value to store
		switch(byte_width_ilist[nvarr])
		{
			case 1:
			if(varlist[nvarr].sl!=0) (varlist[nvarr].psc)[elem_index]=f;
			rsl(f);
			break;
			case 2:
			if(varlist[nvarr].sl!=0) (varlist[nvarr].psi)[elem_index]=f;
			rsl(f);
			break;
			case 4:
			if(varlist[nvarr].sl!=0) (varlist[nvarr].psl)[elem_index]=f;
			rsl(f);
			break;
		}
		break;
	}
}
ans LBL(void)
{
	argptr+=3;
}
ans GOTO(void)
{
	int var;
	var=*(argptr+2);
	argptr=arglbl[var];
	/*int num_var;
	argptr++;
	
	num_var=*(argptr+1);
	while(*argptr!=0xE9)
	{
		foundarg(0x4);//label
		printf("Valeur de argptr=%d",*argptr);
		if(*(argptr+2)==num_var) break;
	}
	if(*argptr==0xE9) return;
	argptr+=3;*/
}
ans endtag(void)
{
argptr++;
rsl(1);
}
ans finish(void)
{
	int ii;
	SetIntVec (AUTO_INT_5, OldInt5);
	OSInitKeyInitDelay(336);
	OSInitBetweenKeyDelay (48);
	if(sv_scr_on==1) {memcpy (LCD_MEM, screen_buffer, LCD_SIZE); free(screen_buffer);}
	for(ii=0;ii<4;ii++)			//free the save screen
	{
		if(scr_copy[ii]!=NULL) free(scr_copy[ii]);
	}
	exit(4);
}
ans isz(void)
{
	argptr+=3;
	rsl(((varlist[*(argptr-1)]).sl++));
}
ans dsz(void)
{
	argptr+=3;
	rsl(((varlist[*(argptr-1)]).sl--));
}
ans iff(void)
{
	//unsigned int delta;
	argptr++;
	if(getsl) {(*(fonc[*(argptr)]))(); }
	else { 
	argptr+=(*(unsigned char*)(argptr+2)+255*(*(unsigned char*)(argptr+1))+1);
	}
}
ans addd(void)
{
	argptr++;
	return (ans)((getsl)+(getsl));
}
ans sub(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)((getsl)-l1);
}
ans mul(void)
{
	argptr++;
	return (ans)((getsl)*(getsl));
}
ans divv(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)((getsl)/l1);
}
ans tohandl(void)
{
	unsigned char hnum;
	ESI arg;
	HANDLE handle;																				
	delete_between (bottom_estack, top_estack); 
	hnum=*(argptr+1);  //num de la variable
	argptr++;
	for(arg=argptr+3;arg<argptr+3+*(argptr+1)*256+*(argptr+2);arg++)
		{
			push_quantum (*arg);
		}
		if((handle = HS_popEStack ())==NULL) exit2("hspop err");
	(varlist[hnum]).h=handle;
	argptr=arg;
	rsl(0);
}
ans freeh(void)
{
	argptr+=3;
	HeapFree ((varlist[*(argptr-1)]).h);
	rsl(0);
}
ans exech(void)
{
	argptr+=3;
	NG_execute ((varlist[*(argptr-1)]).h, FALSE);
	rsl(0);
}
ans finl(void)  //E8
{
	argptr++;
}
ans kwait(void)
{
	argptr++;
	rsl((long)ngetchx());
}

ans xorr(void)
{
	argptr++;
	return (ans)((getsl)^(getsl));
}
ans orr(void)
{
	argptr++;
	return (ans)((getsl)|(getsl));
}
ans andd(void)
{
	argptr++;
	return (ans)((getsl)&(getsl));
}
ans inf(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)(l1<(getsl));
}
ans infeq(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)(l1<=(getsl));
}
ans eq(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)(l1==(getsl));
}
ans supeq(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)(l1>=(getsl));
}
ans sup(void)
{
	long l1;
	argptr++;
	l1=getsl;
	return (ans)(l1>(getsl));
}
ans noteq(void)
{
	long l1,l2;
	argptr++;
	l1=getsl;
	l2=getsl;
	return (ans)(l1!=l2);
}
ans nott(void)
{
	//long l1;
	argptr++;
	return (ans)(~(getsl));
}
/*ans endforr(void)
{
	int index;
	exit2("Endfor function executed!");
	argptr+=3;
	//rsl(1);
}
ans forr(void)
{
	int index;
	long l1,l2,l3,*p;
	index=*(argptr+2);
	argptr+=3;
	p=&varlist[index];
	l1=getsl;
	l2=getsl;
	l3=getsl;
	argendfor[index]=argptr;
/*	for(*p=l1;*p<l2;(*p)+=l3)
	{
		while(argptr<arginter)
		{
			(*(fonc[*(argptr)]))();
		}
		argptr=argdep;
	}
	argptr=arginter+5;

}
*/
/*
ans exitt(void)
{
	argptr++;
	brkvar=0;
}*/
ans ifthen(void)
{
	int var;
	argptr++;
	var=*(argptr+1);
	//printf("var else=%d",var);
	argptr+=2;
	if(!(getsl)) argptr=argelse[var];
}
ans elsee(void)
{
	int var;
	argptr++;
	var=*(argptr+1);
	//printf("var endif=%d",var);
	//printf("\n*argptr=%x &=%x %s",*argptr,(int)(argptr-argdep+2),foncs[*argptr]);
	argptr=argendif[var];
	//printf("\n*argptr=%x &=%x %s",*argptr,(int)(argptr-argdep+2),foncs[*argptr]); ngetchx();
}
ans endif(void)
{
	argptr+=3;
}
ans GOTOL(void)
{
	argptr+=*(argptr+1)*255+*(argptr+2)+1;
}
ans WHILE(void)	//while_tag char_num_while condition
{
	ESI arg;
	int var;
	argptr++;
	arg=argptr;
	var=*(argptr+1);	//numero du while
	argptr+=2;
	//argptr pointe maintenant sur la condition
	if(!(getsl))
	{
		argptr=argendwhile[var];
	}
}
ans EDWHILE(void)
{
	int var;
	argptr++;
	var=*(argptr+1);
	argptr=argwhile[var];
}
ans nop(void)
{
	argptr++;
}
ans mallo(void)
{
	unsigned int l;
	argptr++;
	l=getsl;
	rsl((unsigned char*)malloc(l));
}
ans fre(void)
{
	unsigned char *p;
	argptr++;
	p=getpuc;
	//p=getsl;
	free(p);
	
}
ans pokb(void)	//pokb(address,val)
{
	char *p;
	//char b;
	argptr++;
	p=getpuc;
	*(p)=getsl;
	rsl(*p);
}
ans pokw(void)
{
	int *p;
	//int b;
	argptr++;
	p=getpui;
	*(p)=getsl;
	rsl(*p);
}
ans pokl(void)
{
	long *p;
	//long b;
	argptr++;
	p=getpul;
	*(p)=getsl;
	rsl(*p);
}
ans pekb(void)
{
	char *p;
	argptr++;
	p=getpuc;
	rsl(*p);
}
ans pekw(void)
{
	int *p;
	argptr++;
	p=getpui;
	rsl(*p);
}
ans pekl(void)
{
	long *p;
	argptr++;
	p=getpul;
	rsl(*p);
}
ans repeat(void)
{
	register long i,nb;
	ESI arg;
	argptr++;
	nb=getsl;
	arg=argptr;
	for(i=0;i<nb;i++)
	{
		argptr=arg;
		(*(fonc[*(argptr)]))();
	}
}
ans gotopos(void)
{
	argptr++;
	argptr=getsl;
}
ans pos(void)
{
	argptr++;
	rsl(argptr);
}
ans rts(void)
{
	nsubfonc--;
	argptr=subfonc[nsubfonc];
//printf("\nrts *argptr=%x &=%x %s",*argptr,(int)(argptr-argdep+2),foncs[*argptr]); ngetchx();
}
/*ans jsr(void)
{
	argptr++;
	subfonc[nsubfonc]=argptr+2;
	nsubfonc++;
	argptr=arglbl[*(argptr+1)];
}*/
ans jsr(void)
{
	argptr++;
	subfonc[nsubfonc]=argptr+2;
	nsubfonc++;
	argptr=arglbl[*(argptr+1)];
	exec_none_stop();
}
ans foncc(void)
{
	/*char l;
	argptr++;
	if(*argptr==5) subfonc[nsubfonc]=argptr+2;
	else subfonc[nsubfonc]=argptr+3;
	nsubfonc++;
	*/
	argptr++;
	exit2("Function must be called");
}


ans belm(void)
{
	unsigned char* address;
	unsigned int row;
	argptr++;
	address=getsl;	//address de la liste
	row=getsl;
	rsl(((char*)address)[row]);
}
ans welm(void)
{
	int* address;
	unsigned int row;
	argptr++;
	address=getsl;	//address de la liste
	row=getsl;
	rsl(address[row]);
}
ans lelm(void)
{
	long* address;
	unsigned int row;
	argptr++;
	address=getpuc;	//address de la liste
	row=getsl;
	rsl(address[row]);
}
ans rwky(void)	//row de 0  8 et mask de 0  255
{
	int row,mask;
	argptr++;
	row=getsl;
	mask=getsl;
//	rsl(_rowread(0xffff-1<<row)&mask); 
	rsl(_rowread_inverted(row)&mask); 
}

ans mklist(void)	//num_of_var,nbelem,size_of_elem
{
	unsigned char varn;
	unsigned int dimelem,nbelemm,i;
	argptr++;
	varn=*argptr;
	argptr++;
	//printf("num of var = %d",varn);
	//dimelem=getsl;
	nbelemm=getsl;
	//printf("nbelem = %d",nbelemm);
	
	//nbelemm=getsl;		//Has been retired from the compilator because not useful for the programmer point of view
	dimelem=getsl;
	//printf("dimelem = %d",dimelem);
	
	//printf("Size of elem = %d",varn);
	varlist[varn]=(ans)((unsigned char*)malloc(dimelem*nbelemm));
	byte_width_ilist[varn]=dimelem;
	//printf("\nvarn=%d dimelem=%d nbelem=%d\n",varn,dimelem,nbelemm); ngetchx();
	for(i=0;i<nbelemm;i++)
	{
			/*if(*argptr==MINUS_TAG)
			{
				printf("C'est un MINUS_TAG"); ngetchx();
				argptr++;
			}*/
			switch(dimelem)
		{
			case 1:
			if(*argptr==MINUS_TAG)
			{
				//printf("C'est un MINUS_TAG"); //ngetchx();
				argptr++; poke(varlist[varn].puc+i,-getsl);
			} else poke(varlist[varn].puc+i,getsl);
			break;
			case 2:
			if(*argptr==MINUS_TAG)
			{
				//printf("C'est un MINUS_TAG"); //ngetchx();
				argptr++; poke_w(varlist[varn].puc+i*2,-getsl);
			} else poke_w(varlist[varn].puc+i*2,getsl);
			break;
			case 4:
			if(*argptr==MINUS_TAG)
			{
				//printf("C'est un MINUS_TAG"); //ngetchx();
				argptr++; poke_l(varlist[varn].puc+i*4,-getsl);
			} else poke_l(varlist[varn].puc+i*4,getsl);
			break;
		}	
	}
	rsl(varlist[varn].puc);
	
}
ans dline(void)	// dline(xa,ya,xb,yb)
{
	unsigned char xa,ya,xb,yb;
	argptr++;
	xa=getsl;
	ya=getsl;
	xb=getsl;
	yb=getsl;
	DrawLine(xa,ya,xb,yb,gmode);
}
ans dmline(void)		//syntax : dmline(liste_de_chars_abscisse,liste_de_chars_ordonns,nombre_de_points)
{
	unsigned char *xa,*ya,xi,yi,xf,yf;
	long nbpoints,ii;
	argptr++;
	xa=getsl;
	ya=getsl;
	nbpoints=getsl;
	xi=xa[0];
	yi=ya[0];
	for(ii=1;ii<nbpoints;ii++)
	{
		xf=xa[ii];
		yf=ya[ii];
		DrawLine(xi,yi,xf,yf,gmode);
		xi=xf;
		yi=yf;
	}
	
}
ans setgmod(void)
{
	char old_gmode;
	argptr++;
	old_gmode=gmode;
	gmode=getsl;
	rsl(old_gmode);
}
ans fope(void)
{
	char *strna,*strmod;
	FILE *ffile;
	argptr++;
	strna=getpuc;
	strmod=getpuc;
	ffile=fopen(strna,strmod);
	rpfile(ffile);
}
ans fclos(void)
{
	FILE *ffile;
	argptr++;
	ffile=getpfile;
	rsl(fclose(ffile));
}
ans fptc(void)
{
	int val;
	FILE *ffile;
	argptr++;
	val=getsl;
	ffile=getpfile;
	rsl(fputc(val,ffile));
}
ans fpts(void)
{
	char *strr;
	FILE *ffile;
	argptr++;
	strr=getpuc;
	ffile=getpfile;
	rsl(fputs(strr,ffile));
}
ans fgts(void)
{
	char *buf;
	long num_of_chars;
	FILE* ffile;
	argptr++;
	buf=getpuc;
	num_of_chars=getsl;
	ffile=getpfile;
	rpuc(fgets(buf,num_of_chars,ffile));
}
ans fgtc(void)
{
	FILE* ffile;
	argptr++;
	ffile=getpfile;
	rsl(fgetc(ffile));
}
ans printc(void)
{
	unsigned char c;
	argptr++;
	c=getsl;
	printf("%c",c);
}
ans gts(void)
{
	char *buff;
	argptr++;
	buff=getpuc;
	rpuc(gets(buff));
}
ans sprntf(void)
{
	char *buff,*strr;
	long arg;
	argptr++;
	buff=getpuc;
	strr=getpuc;
	arg=getsl;
	rpuc(sprintf(buff,strr,arg));
}
ans chars(void)
{
	unsigned char c;
	ESI argptrr;
	argptr++;
	argptrr=argptr;
	argptr+=2;
	c=getsl;
	*(argptrr)=(char)c;
	rpuc(argptrr);
}
ans strct(void)
{
	char *d,*s;
	argptr++;
	d=getpuc;
	s=getpuc;
	rpuc(strcat(d,s));
}
ans sprt8(void)
{
	short x,y,h;
	unsigned char *sprite;
	//void *video_mem;
	argptr++;
	x=getsl;
	y=getsl;
	h=getsl;
	sprite=getpuc;
	//video_mem=getsl;
	//Sprite8(x,y,height,sprite, 0x4c00, gmode);
	Sprite8 (x, y, h, sprite, lcdad, gmode);
}
ans sprt16(void)
{
	short x,y,height;
	unsigned int *sprite;
	//void *video_mem;
	argptr++;
	x=getsl;
	y=getsl;
	height=getsl;
	sprite=getpuc;
	//video_mem=getsl;
	Sprite16(x,y,height,sprite, lcdad, gmode);
}
ans sprt32(void)
{
	short x,y,height;
	unsigned long *sprite;
	//void *video_mem;
	argptr++;
	x=getsl;
	y=getsl;
	height=getsl;
	sprite=getpuc;
	//video_mem=getsl;
	Sprite32(x,y,height,sprite, lcdad, gmode);
}
ans mmset(void)
{
	char *buff;
	short val;
	unsigned int num;
	argptr++;
	buff=getpuc;
	val=getsl;
	num=getsl;
	rsl(memset(buff,val,num));
}
ans map(void)
{
	unsigned char varnum;
	long st,en,ste,*p;
	ESI argdeb;
	argptr++;
	varnum=*(argptr+1);
	p=&varlist[varnum];
	argptr+=2;
	st=getsl;
	en=getsl;
	ste=getsl;
	//printf("DANS MAP st=%ld en=%ld ste=%ld ",st,en,ste);
	argdeb=argptr;
	for(*p=st;*p!=en;*p+=ste)
	{
		(*(fonc[*(argptr)]))();
		//printf("\ncoucou");
		argptr=argdeb;
	}
	return (*(fonc[*(argptr)]))();
}
ans multi(void)
{
	int n,i;	//nombre de lignes
	argptr++;
	n=getsl;
	for(i=1;i<n;i++)
	{
		(*(fonc[*(argptr)]))();
	}
	return (*(fonc[*(argptr)]))();
}
ans two(void)
{
	argptr++;
	(*(fonc[*(argptr)]))();
	return (*(fonc[*(argptr)]))();
}
ans setlcd(void)
{
	void *vmem,*vmemori;
	argptr++;
	vmemori=vmem;
	vmem=getpuc;
	lcdad=vmem;
	PortSet (vmem, 239, 127); // redirect drawing routines to buffer
	rsl(vmemori);
}
ans getlcd(void)
{
	argptr++;
	rsl(lcdad);
}
ans dpix(void)
{
	int x,y;
	argptr++;
	x=getsl; y=getsl;
	DrawPix (x,y,gmode);
}
ans gpix(void)
{
	int x,y;
	argptr++;
	x=getsl; y=getsl;
	rsl(GetPix (x,y));
}
ans gryon(void)
{
	argptr++;
	rsl(GrayOn());
}
ans gryoff(void)
{
	argptr++;
	GrayOff();
}
ans ligh(void)
{
	argptr++;
	GraySetAMSPlane (LIGHT_PLANE);
  lcdad=GrayGetPlane(LIGHT_PLANE);
}
ans dar(void)
{
	argptr++;
	GraySetAMSPlane (DARK_PLANE);
	lcdad=GrayGetPlane(DARK_PLANE);
}
ans fillrec(void)
{
	static SCR_RECT rect;
	argptr++;
	rect.xy.x0=getsl;
	rect.xy.y0=getsl;
	rect.xy.x1=getsl;
	rect.xy.y1=getsl;
	ScrRectFill (&rect, &scr_rect, gmode);
}
ans clrdrw(void)
{
	long *ptrrr;
	int ii;
	ptrrr=lcdad;
	for(ii=0;ii<LCD_SIZE/4;ii++) ptrrr[ii]=0;
	argptr++;
	//ClrScr();
}
ans scrleft(void)
{
	register short* tmpbuffer;
  register short  tmplines;
	argptr++;
	
	tmpbuffer=lcdad;
	tmplines=getsl;
  tmpbuffer += (tmplines<<4) - (tmplines);
  
  tmplines--;
    asm volatile ("0:\n"
        "lea -10(%0),%0\n"
        "lsl.w  -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0)\n"
        "roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0)\n"
        "dbf %1,0b"
        : "=a" (tmpbuffer), "=d" (tmplines)
        : "0"  (tmpbuffer), "1"  (tmplines));
}
ans scrleft2(void)
{
	register short* tmpbuffer;
  register short  tmplines;
	argptr++;
	
	tmpbuffer=lcdad;
	tmplines=getsl;

    tmpbuffer += (tmplines<<4) - (tmplines);
    tmplines--;

    asm volatile ("0:\n"
        "lsl.w  -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0)\n"
        "roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0)\n"
        "roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0);roxl.w -(%0)\n"
        "dbf %1,0b"
        : "=a" (tmpbuffer), "=d" (tmplines)
        : "0"  (tmpbuffer), "1"  (tmplines));
}
ans scrrigh(void)
{
	register short* tmpbuffer;
  register short  tmplines;
	argptr++;
	tmpbuffer=lcdad;
	tmplines=getsl;

    tmplines--;

    asm volatile ("0:\n"
        "lsr.w  (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+\n"
        "roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+\n"
        "lea 10(%0),%0\n"
        "dbf %1,0b"
        : "=a" (tmpbuffer), "=d" (tmplines)
        : "0"  (tmpbuffer), "1"  (tmplines));
}

ans scrrigh2(void)
{
	register short* tmpbuffer;
  register short  tmplines;
	argptr++;
	tmpbuffer=lcdad;
	tmplines=getsl;

    tmplines--;

    asm volatile ("0:\n"
        "lsr.w  (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+\n"
        "roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+\n"
        "roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+;roxr.w (%0)+\n"
        "dbf %1,0b"
        : "=a" (tmpbuffer), "=d" (tmplines)
        : "0"  (tmpbuffer), "1"  (tmplines));
}

ans scrup(void)
{
	register short* dest;
  register short* src;
  register short  tmplines;
	argptr++;
	dest=lcdad;
	src=dest+15;
	tmplines=getsl;

  tmplines -= 2;

    asm volatile ("0:\n"
        "move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+\n"
        "move.l (%0)+,(%1)+;move.l (%0)+,(%1)+\n"
        "lea 10(%0),%0\n"
        "lea 10(%1),%1\n"
        "dbf %2,0b\n"
        "clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.l (%1)+"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src),  "1" (dest), "2"  (tmplines));
}
ans scrup2(void)
{
	register short* dest;
  register short* src;
  register short  tmplines;
	argptr++;
	dest=lcdad;
	src=dest+15;
	tmplines=getsl;

  tmplines -= 2;

    asm volatile ("0:\n"
        "move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+\n"
        "move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+\n"
        "move.l (%0)+,(%1)+;move.w (%0)+,(%1)+\n"
        "dbf %2,0b\n"
        "clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.l (%1)+\n"
        "clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.w (%1)+"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src),  "1" (dest), "2"  (tmplines));
}
ans scrbot(void)
{
	register short* dest;
  register short* src;
  register short  tmplines;
	argptr++;
	dest=lcdad;
	src=dest+15;
	tmplines=getsl;

  dest += (tmplines<<4) - (tmplines) - 5;
    src   = dest - 15;

    tmplines -= 2;

    asm volatile ("0:\n"
        "move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)\n"
        "move.l -(%0),-(%1);move.l -(%0),-(%1)\n"
        "lea -10(%0),%0\n"
        "lea -10(%1),%1\n"
        "dbf %2,0b\n"
        "clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.l -(%1)"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src), "1"  (dest), "2"  (tmplines));
}
ans scrbot2(void)
{
	register short* dest;
  register short* src;
  register short  tmplines;
	argptr++;
	dest=lcdad;
	src=dest+15;
	tmplines=getsl;

  dest += (tmplines<<4) - (tmplines);
    src   = dest - 15;

    tmplines -= 2;

    asm volatile ("0:\n"
        "move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)\n"
        "move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)\n"
        "move.l -(%0),-(%1);move.w -(%0),-(%1)\n"
        "dbf %2,0b\n"
        "clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.l -(%1)\n"
        "clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.w -(%1)"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src), "1"  (dest), "2"  (tmplines));
}
ans drwstr(void)
{
	unsigned char x,y,*pstr;
	argptr++;
	x=getsl;
	y=getsl;
	pstr=getpuc;
	DrawStr(x,y,pstr,gmode);
}
ans setfontt(void)
{
	argptr++;
	rsl(FontSetSys (getsl));
}
ans lrol(void)
{
	long val;
	char n;
	argptr++;
	val=getsl;
	n=getsl;
	rsl(val<<n);
}
ans rrol(void)
{
	long val;
	char n;
	argptr++;
	val=getsl;
	n=getsl;
	rsl(val>>n);
}
ans tios(void)
{
	HANDLE handle;
	unsigned char *str;
	argptr++;
	str=getpuc;
	push_parse_text (str);
	handle = HS_popEStack ();
	NG_execute (handle, FALSE);
	HeapFree (handle);
	switch(GetArgType(top_estack))
	{
		case NEGINT_TAG:
		rsl(-GetIntArg(top_estack));
		break;
		case POSINT_TAG:
		rsl(GetIntArg(top_estack));
		break;
		case STR_TAG:
		rsl(GetStrnArg(top_estack));
		break;
		case LIST_TAG:
		printf("\ncommand os cannot return list.");
		break;
		//en supposant ci dessous que c'est un ngatif (MINUS -)
		}
}
ans debugon(void)
{
	argptr++;
	printf("\nDEBUG ON :");
	while(*argptr!=0xE9 && *argptr!=241)	//0xf1=241=debugoff
	{
		printf("\n*argptr=%x &=%x %s",*argptr,(int)(argptr-argdep+2),foncs[*argptr]); ngetchx();
		(*(fonc[*(argptr)]))();
	}
	(*(fonc[*(argptr)]))();
	printf("\nDEBUG OFF\n");
	rsl(0);
}
ans DEBUGOF(void)
{
	argptr++;
}
ans nilist(void)	//execute the content of the nilist !?? ->pass?
{
	long d/*,i*/,s;
	ESI argdeb;
	argdeb=argptr;
	argptr++;
	s=getsl;	//size of data
	d=getsl;	//number of data
	//printf("\ntaille : %d\nNombre d'elements : %d",(int)s,(int)d);
	//for(i=0;i<d;i++) (*(fonc[*(argptr)]))();
	argptr+=s;
	rsl(argdeb);
}
ans toos(void)
{
	char *dest_file,*str;
	long val,s,n,i;
	int type,varn/*,aeff*/;
	ESI sptr,sptr_deb,sp1,sp2;
	ESI next_sptr,argptrd,argptrs;
	HANDLE handle;
	type=OTH_TAG;
	argptr++;
	if(*argptr!=1 && *argptr!=2 && *argptr!=3 && *argptr!=11 && *argptr!=12 && *argptr!=1 && *argptr!=37 && *argptr!=38 && *argptr!=122 && *argptr!=153 && *argptr!=45 && *argptr!=14 && *argptr!=216)
	{ //s'occupe des fonctions
		val=getsl;
		dest_file=getpuc;
		handle = CreateFile (dest_file);
		push_longint (val);
		sptr_deb=top_estack;
		sptr=sptr_deb;
		next_sptr=sptr;
		type=GetArgType (sptr);
		if(type!=END_TAG) SkipArg (next_sptr);
		//printf("Stack=\n");
		next_sptr++;
		while(*next_sptr!=type)
		{
			//printf("  %x",*next_sptr);
			AppendCharToFile(handle,*next_sptr);
			next_sptr++;
		}
		delete_expression (sptr_deb);
	}
	switch(*argptr)
	{
		case 1:	//guchar
		case 2:	//gslvar
		case 3:	//gpvar
		case 11:	//guint
		case 12:	//gint
		case 37:	//glong
		case 38:	//gulong
		case 122:	//neg
		case 153://fc fonctions newprog inlines
		val=getsl;
		dest_file=getpuc;
		handle = CreateFile (dest_file);
		push_longint (val);
		sptr_deb=top_estack;
		sptr=sptr_deb;
		next_sptr=sptr;
		type=GetArgType (sptr);
		if(type!=END_TAG) SkipArg (next_sptr);
		//printf("Stack=\n");
		next_sptr++;
		while(*next_sptr!=type)
		{
			//printf("  %x",*next_sptr);
			AppendCharToFile(handle,*next_sptr);
			next_sptr++;
		}
		delete_expression (sptr_deb); 
		break;
		case 45:	//gstr=string
		str=getpuc;
		dest_file=getpuc;
		handle = CreateFile (dest_file);
		AppendStrToFile (handle, str);
		type=STR_TAG;
		break;
		case 14:		//indirection
		//Se charge de pointer   la nilist pointe par varn
		varn=*(argptr+1);	//numro de la variable
		argptr+=2;
		dest_file=getpuc;
		argptrd=argptr;
		argptr=((varlist[varn]).sl);
		argptrs=argptr;
		//printf("type=%d",*(argptr-3)); ngetchx();
		if(*argptr!=216 && *(argptr-3)!=45) exit2("nilist or string var expected with indirection");	//maintenant argptr pointe sur la donne
		if(*argptr==216) 
		{
		type=LIST_TAG;
		sptr_deb=top_estack;
		argptr++;
		s=getsl;
		n=getsl;
		handle = CreateFile (dest_file);
		delete_between(top_estack,bottom_estack);
		push_quantum(END_TAG);
		sp1=top_estack;	//sp1 pointe sur endtag
		for(i=0;i<n;i++)
		{
			if(*argptr==45)
			{
				push_zstr(getpuc);
			}
			else
			{
				push_longint (getsl);
			}
			
		}
		push_quantum(LIST_TAG);
		sp2=top_estack;	//sp2 pointe sur LIST_TAG
		delete_between(top_estack,bottom_estack);
		sptr=top_estack;
		sptr=sp1;	//pointe sur le premier byte  inscrire dans le fichier (E5)
		while(sptr<sp2)
		{
			AppendCharToFile(handle,*sptr);
			sptr++;
		}
		delete_between(top_estack,bottom_estack);
		//AppendCharToFile(handle,*next_sptr);
		}
		
		if(*(argptrs-3)==45&&*(argptr-2)==1)
		{
			argptr=argptrs-3;
			handle = CreateFile (dest_file);
			AppendStrToFile (handle, getpuc);
			type=STR_TAG;
		}
		else
		{
			if(*(argptrs-4)==45&&*(argptr-3)==POSINT_TAG)
		 {
			argptr=argptrs-4;
			handle = CreateFile (dest_file);
			AppendStrToFile (handle, getpuc);
			type=STR_TAG;
		 }
		}
		
	
		argptr=argptrd;
		
		break;
		case 216:		//nilist
		sptr=argptr+1;
		nilist();	//passe la nilist pour trouver le fichier de destination
		dest_file=getpuc;
		argptr=sptr;		//retourne au dbut de la nilist
		sptr_deb=top_estack;
		s=getsl;
		n=getsl;
		handle = CreateFile (dest_file);
		push_quantum(END_TAG);
		sp1=top_estack;	//sp1 pointe sur endtag
		for(i=0;i<n;i++)
		{
			if(*argptr==45)
			{
				push_zstr(getpuc);
			}
			else
			{
				push_longint (getsl);
			}
			
		}
		push_quantum(LIST_TAG);
		sp2=top_estack;	//sp2 pointe sur LIST_TAG
		delete_between(top_estack,bottom_estack);
		sptr=top_estack;
		sptr=sp1;	//pointe sur le premier byte  inscrire dans le fichier (E5)
		while(sptr<sp2)
		{
			AppendCharToFile(handle,*sptr);
			sptr++;
		}
		delete_between(top_estack,bottom_estack);
		type=LIST_TAG;
		break;
		/*// Pour tous les autres types, dont les fonctions
		printf("  JESUS EST LA"); ngetchx();
		val=getsl;
		dest_file=getpuc;
		handle = CreateFile (dest_file);
		push_longint (val);
		sptr_deb=top_estack;
		sptr=sptr_deb;
		next_sptr=sptr;
		type=GetArgType (sptr);
		if(type!=END_TAG) SkipArg (next_sptr);
		//printf("Stack=\n");
		next_sptr++;
		while(*next_sptr!=type)
		{
			//printf("  %x",*next_sptr);
			AppendCharToFile(handle,*next_sptr);
			next_sptr++;
		}
		delete_expression (sptr_deb);*/ 
	}
  CloseFile_type (handle,type);
  rsl(handle);
}
ans prints(void)
{
	argptr++;
	printf("%s",getpuc);
}
ans ifs(void)
{
	long /*cond,*/num;
	int i;
	ans anss;
	argptr++;
	if(getsl)
	{
		argptr++;		//ce if ne doit pas contenir une instruction d'une taille suprieure  255 octets
		getsl;
		num=getsl;
		for(i=0;i<num;i++) anss=((*(fonc[*(argptr)]))());
		nilist();
		//(*(fonc[*(argptr)]))();
	}
	else 
	{
		nilist();	//pass the nilist
		//(*(fonc[*(argptr)]))();
		if(*argptr!=216) exit2("pas une nilist");
		argptr++;			//arrive au deuxieme nilist ; passe le tag de nilist
		getsl;			//passe la taille
		num=getsl;
		for(i=0;i<num;i++) anss=((*(fonc[*(argptr)]))());
	}
	return anss;
}
ans indir(void)	//excute une nilist pointe par le contenu de la variable
{
	unsigned char varn;
	long s,n,i;
	ans r;
	ESI argptrr;
	argptr++;
	argptrr=argptr+1;	//pointe aprs l'instruction
	varn=*argptr;		//numro de la variable
	argptr=(varlist[varn]).sl;	//maintenant argptr pointe sur la donne
	switch(*argptr)
	{
		case 216: //nilist
		argptr++;
		s=getsl;
		n=getsl;
		for(i=0;i<n;i++)
		{
			r=((*(fonc[*(argptr)]))());
		}
		break;
	}
	argptr=argptrr;							//retourne au PC initial
	return r;										//renvoie le rsultat de l'instruction excute
}
ans atoll(void)
{
	argptr++;
	rsl(atol(getsl));
}
ans def(void)	//definition  fonctions !
{
	unsigned char nf;	//num of the function
	unsigned char i,v;
	ESI argptrf,argptrs;
	i=0; v=0;
	argptrf=argptr+3;
	argptr++;
	//now we point on the var of the function
	nf=*(argptr+1);
	argfunc[nf]=argptrf; //enregistre le pointer de debut
	argptrs=foundarg(151);	//search for end of definition : func enddef
	if(*(argptrs+2)==nf) argendfunc[nf]=argptrs+3;
	else exit2("Error at the end of the\nfunction definition.\nenddef() missing ?");
	argptr=argptrs+3;
}
ans enddef(void) //This function is not usually executed
{
	argptr+=3;
}
ans f(void) //execute une fonction : f(nom_var_fonction,arg)
{
	unsigned char nf;
	ESI argptrf,argptrend;
	argptr++;
	nf=*(argptr+1);
	argptr+=2;
	argin[i_rtnf+1]=getsl;
	i_rtnf++;  //permet de passer comme argument  la fonction l'argument de la fonction prcdente
	argptrend=argptr;
	argptrf=argendfunc[nf]-3;
	argptr=argfunc[nf];
	rtnf[i_rtnf]=argptrend; //We store the exit position to be able to exit the func with rtn() function 
	while(argptr<argptrf) {(*(fonc[*(argptr)]))();}
	argptr=argptrend;
	i_rtnf--;
	rsl(rtnf[i_rtnf+1]);
}
ans rtn(void)
{
	ESI argptrs;
	argptr++;
	argptrs=rtnf[i_rtnf];
	rtnf[i_rtnf]=getsl;
	argptr=argptrs;
}
ans arg(void)
{
	argptr++;
	rsl(argin[i_rtnf]);
}
ans group(void) //instancie une nilist et alloue un espace mmoire {long_nb_elem,long_elem1,long_elem2...}
{
	unsigned int num,i;
	long *mem;
	argptr++;
	if(*argptr!=216) exit2("Group expecting for nilist {}");
	argptr++;		//passe le tag nilist
	getsl;	//passe la taille
	num=getsl; //prend le nombre d'lments de la nilist
	mem=malloc(num*4+4);
	mem[0]=num;
	for(i=0;i<num;i++)
	{
		mem[i+1]=getsl;
	}
	rsl(mem);
}
ans code(void)
{
	char *strr;
	argptr++;
	strr=getpuc;
	rsl(strr[0]);
}
ans wb(void) //adress,elem,val
{
	char *a;
	int elem;
	long val;
	argptr++;
	a=getpuc;
	elem=getsl;
	val=getsl;
	*(a+elem)=val;
	rsl(val);
}
ans ww(void)
{
	int *a;
	int elem;
	long val;
	argptr++;
	a=getpuc;
	elem=getsl;
	val=getsl;
	*(a+elem)=val;
	rsl(val);
}
ans wl(void)
{
	long *a;
	int elem;
	long val;
	argptr++;
	a=getpuc;
	elem=getsl;
	val=getsl;
	*(a+elem)=val;
	rsl(val);
}

ans inter(void)  //format : inter(interupt_identificiator,speed(1=Max speed), {instruction1,instruction2,...}
{
	unsigned char id,speed;
	argptr++;
	id=getsl; id++;
	if(id==1) //disable all newprog interupts
	{
		for(speed=1;speed<=21;speed++) speedintr[speed]=0;
	}
	speed=getsl;
	//printf("\ndans inter, id=%d",id);
	argintr[id]=argptr; //pointe sur la nilist a execute
	speedintr[id]=speed;
}
ans introff(void)
{
	argptr++;
	OSSetSR (0x0700);
}
ans intron(void)
{
	argptr++;
	OSSetSR (0x0000);
}
ans int1off(void)
{
	argptr++;
	//printf("deb int1off");
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
	//printf("fin int1off");
}
ans int1on(void)
{
	argptr++;
	//printf("deb int1on");
	SetIntVec (AUTO_INT_1, save_int_1);
	//printf("fin int1on");
}
ans freet(void)
{
	argptr++;
	rsl(OSFreeTimer (getsl));
}
ans sett(void)
{
	char timer_no;
	unsigned long init_val;
	argptr++;
	timer_no=getsl;
	init_val=getsl;
	rsl(OSRegisterTimer (timer_no, init_val));
}
ans texp(void)
{
	short timer_no;
	argptr++;
	timer_no=getsl;
	if(OSTimerExpired (timer_no)) rsl(1);
	else rsl(0);
}
ans tval(void)
{
	argptr++;
	rsl(OSTimerCurVal (getsl));
}
ans int5off(void)
{
	argptr++;
	int5_allowed=0;
}
ans int5on(void)
{
	argptr++;
	int5_allowed=1;
}
ans asm_cal(void)
{
	argptr++;
	ASM_call (getpuc);
}

/*ans setrate(void) //compil mais elle n'avait pas d'influence sur la rapidit du int 5 !?!
{
	argptr++;
	EnablePRG();
	PRG_setRate (getsl);
}*/
ans ctup(void)
{
	argptr++;
	OSContrastUp();
}
ans ctdown(void)
{
	argptr++;
	OSContrastDn();
}
ans printd(void)
{
	//long vv;
	argptr++;
	//vv=getsl;
	//printf("Valeur a afficher %ld\n",vv); ngetchx();
	printf("%ld",getsl);
}
ans printxy(void)
{
	short x,y;
	unsigned char *cptr;
	argptr++;
	x=getsl; y=getsl; cptr=getpuc;
	printf_xy (x, y, cptr, getsl);
}
ans idlee(void)
{
	argptr++;
	idle();
}
ans scrrect(void)
{
	argptr++;
	scr_rect.xy.x0=getsl;
	scr_rect.xy.y0=getsl;
	scr_rect.xy.x1=getsl;
	scr_rect.xy.y1=getsl;
}
ans strlenn(void)
{
	argptr++;
	rsl(strlen(getpuc));
}
ans newstr(void)
{
	unsigned char *strr,*buff,varn;
	unsigned long i,l;
	argptr++;
	strr=getpuc;
	varn=*(argptr+1);
	argptr+=2;
	l=strlen(strr);
	buff=malloc(l+1);
	if(!buff) exit2("In newstr,\nNot enough memory");
	for(i=0;i<(l+1);i++) *(buff+i)=*(strr+i);
	varlist[varn].sl=buff;
	rpuc(buff);
}
ans seql(void)	//mapl(var,start,end,step,var_dest,instruction)
{
	unsigned char varnum,vardest;
	long st,en,ste,*p,*ptemp,i;
	ESI argdeb;
	argptr++;
	varnum=*(argptr+1);
	p=&varlist[varnum];
	byte_width_ilist[varnum]=4;	//Not very useful for seql because already initialise to 4 in main()
	argptr+=2;
	st=getsl;
	en=getsl;
	ste=getsl;
	vardest=*(argptr+1);
	byte_width_ilist[vardest]=4;
	argptr+=2;
	argdeb=argptr;
	i=0;
	if(((en-st)%ste)!=0) exit2("Seql error\n (end-start)/step\nis not an integer");
	if(((en-st)/ste)<0) return (ans)0;
	ptemp=malloc(4*((en-st)/ste+1)); //+1 for memory security : i.e. bad programmation, laught
	(varlist[vardest].puc)=ptemp;
	if(ptemp==NULL) exit2("Memory error in Seql");
	for(*p=st;*p!=en;*p+=ste)
	{
		*(ptemp+i)=(*(fonc[*(argptr)]))().sl;
		i++;
		argptr=argdeb;
	}
	rsl (*(ptemp+i)=(*(fonc[*(argptr)]))().sl);
}
ans seqw(void)
{
	unsigned char varnum,vardest;
	long st,en,ste,*p,i;
	int *ptemp;
	ESI argdeb;
	argptr++;
	varnum=*(argptr+1);
	p=&varlist[varnum];
	argptr+=2;
	st=getsl;
	en=getsl;
	ste=getsl;
	vardest=*(argptr+1);
	byte_width_ilist[vardest]=2;
	argptr+=2;
		argdeb=argptr;
	i=0;
	if(((en-st)%ste)!=0) exit2("Seqw error\n (end-start)/step\nis not an integer");
	if(((en-st)/ste)<0) return (ans)0;
	ptemp=malloc(2*((en-st+1)/ste)+1); //+1 for memory security : i.e. bad programmation, laught
	(varlist[vardest].puc)=ptemp;
	if(ptemp==NULL) exit2("Memory error in Seqw");
	for(*p=st;*p!=en;*p+=ste)
	{
		*(ptemp+i)=(*(fonc[*(argptr)]))().sl;
		i++;
		argptr=argdeb;
	}
	rsl (*(ptemp+i)=(*(fonc[*(argptr)]))().sl);
}
ans seqb(void)	//mapl(var,start,end,step,var_dest,instruction)
{
	unsigned char varnum,vardest;
	long st,en,ste,*p,i;
	char *ptemp;
	ESI argdeb;
	argptr++;
	varnum=*(argptr+1);
	p=&varlist[varnum];
	argptr+=2;
	st=getsl;
	en=getsl;
	ste=getsl;
	vardest=*(argptr+1);
	byte_width_ilist[vardest]=1;
	argptr+=2;
	argdeb=argptr;
	i=0;
	if(((en-st)%ste)!=0) exit2("seqb error\n (end-start)/step\nis not an integer");
	if(((en-st)/ste)<0) return (ans)0;
	ptemp=malloc((en-st)/ste+1);  //+1 for memory security : i.e. bad programmation, laught
	(varlist[vardest].puc)=ptemp;
	if(ptemp==NULL) exit2("Memory error in Seqb");
	for(*p=st;*p!=en;*p+=ste)
	{
		*(ptemp+i)=(*(fonc[*(argptr)]))().sl;
		i++;
		argptr=argdeb;
	}
	rsl (*(ptemp+i)=(*(fonc[*(argptr)]))().sl);
}

ans loadasm(void)
{
	char *fptr, *cptr,file[18];
  unsigned short plen;
  File *fileptr;
  SYM_ENTRY *SymPtr;
  HANDLE h;
  argptr++;
  strcpy(file,getpuc);
  SymPtr = DerefSym (SymFind (SYMSTR (file)));
  if (!SymPtr) exit2("Asm file not found");
  h = SymPtr->handle;
  if (HeapGetLock (h))
    {
      cptr = fptr = HeapDeref (h);
      h = 0;
    }
  else
    {
      cptr = fptr = HLock (h);
    }
  plen = *(short*)(cptr) + 3;
  if (SymPtr->flags.bits.archived)
    {
      if (!(cptr = malloc (plen)))
        {
          if (h) HeapUnlock (h);
          exit2("Out of memory to load asm");
        }
      memcpy (cptr, fptr, plen);
    }
  
  if(!(fileptr=malloc(sizeof(File))))
  {
  	if (h) HeapUnlock (h);
  	if (cptr != fptr) free (cptr);
  	exit2("Memory error in loadasm");
  }
  enter_ghost_space ();
  EX_patch (cptr + 0x40002, cptr + plen + 0x3FFFE);
  fileptr->fptr=fptr;
  fileptr->cptr=cptr;
  fileptr->plen=plen;
  fileptr->h=h;
  rsl(fileptr);
}
ans execasm(void)
{
	File *fileptr;
	argptr++;
	fileptr=getpuc;
	//printf("\nDans execasm = %ld",(unsigned long)fileptr); ngetchx();
	ASM_call (fileptr->cptr + 0x40002);
}
ans closeasm(void)
{
	File *fileptr;
	argptr++;
	fileptr=getpuc;
	if (fileptr->h) HeapUnlock (fileptr->h);
  if (fileptr->cptr != fileptr->fptr) free (fileptr->cptr);
  free(fileptr);
}
ans strcmpp(void)
{
	char *s1,*s2;
	argptr++;
	s1=getpuc;
	s2=getpuc;
	rsl(strcmp(s1,s2));
}
ans strcpyy(void)
{
	char *dest,*source;
	argptr++;
	dest=getpuc;
	source=getpuc;
	rsl(strcpy(dest,source));
}
ans fsek(void)
{
	File *stream;
	long offset;
	short whence;
	argptr++;
	stream=getsl;
	offset=getsl;
	whence=getsl;
	rsl(fseek (stream, offset,whence));
}

ans ftel(void)
{
	File *stream;
	argptr++;
	stream=getsl;
	rsl(ftell (stream));
}
 
ans svscroff(void)
{
	argptr++;
	sv_scr_on=0;
	if(screen_buffer!=NULL) free(screen_buffer);
	//printf("Coucoullll"); ngetchx();
}
ans memcpyy(void)
{
	unsigned char *destt,*srcc;
	unsigned int lenn;
	argptr++;
	destt=getpuc;
	srcc=getpuc;
	lenn=getsl;
	memcpy(destt,srcc,lenn);
	//printf("Premiers bytes\norigine : %d\ncopier : %d",*srcc,*destt); ngetchx();
}
ans memmov(void)
{
	unsigned char *destt,*srcc;
	unsigned int lenn;
	argptr++;
	destt=getpuc;
	srcc=getpuc;
	lenn=getsl;
	rsl(memmove(destt,srcc,lenn));
}
ans randd(void)
{
	unsigned int rangee,rr;
	argptr++;
	rangee=getsl;
	rr=random(rangee);
	rsl(rr);
}
ans up(void)
{
	argptr++;
	if(_keytest(RR_UP))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans down(void)
{
	argptr++;
	if(_keytest(RR_DOWN))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans left(void)
{
	argptr++;
	if(_keytest(RR_LEFT))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans right(void)
{
	argptr++;
	if(_keytest(RR_RIGHT))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans second(void)
{
	argptr++;
	if(_keytest(RR_2ND))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans majj(void)
{
	argptr++;
	if(_keytest(RR_SHIFT))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans diamond(void)
{
	argptr++;
	if(_keytest(RR_DIAMOND))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans alpha(void)
{
	argptr++;
	if(_keytest(RR_ALPHA))
	{
		rsl(1);	
	}
	 else rsl(0);
}
ans gkey(void)
{
	unsigned short key;
	argptr++;
	if (!OSdequeue (&key, kbq))
	{
  	rsl(key);
	}
	rsl(0);
}
ans keydlay(void)
{
	unsigned int vv;
	argptr++;
	vv=getsl;
	rsl(OSInitKeyInitDelay (vv));
}
ans keysped(void)
{
	unsigned int vv;
	argptr++;
	vv=getsl;
	rsl(OSInitBetweenKeyDelay (vv));
}
ans llelem(void)		//load a list element
{
	unsigned char varnnn;
	unsigned int nelemm;
	argptr+=2;
	varnnn=*argptr;
	argptr++;
	nelemm=getsl;
	//printf("Byte width%d\nvarnn %d",byte_width_ilist[varnnn],varnnn); ngetchx();
	switch(byte_width_ilist[varnnn])
	{
		case 1:
		rsl(((varlist[varnnn]).psc)[nelemm]);
		break;
		case 2:
		rsl(((varlist[varnnn]).psi)[nelemm]);
		break;
		case 4:
		rsl(((varlist[varnnn]).psl)[nelemm]);
		break;
		exit2("\nError in var[] function");
	}
	
	//printf("Dans llelem%d",nelemm); ngetchx();
}
ans gsprt(void)		//syntax : gsprt(pixel_width,num_line,"pic_var",sprt_var)
{
	unsigned char rval,cval,sprt_dest,iii;
	char *picvar;
	unsigned char *sprtt;
	Files *fpic;
	argptr++;
	cval=getsl;		//number of columns in byte (8,16 ot 32 only)
	rval=getsl;		//number of rows from 1 to TBD
	sprtt=malloc(cval*rval);
	if(sprtt==NULL) exit2("\nMemory Error");	
	if(*argptr!=STR_TAG) exit2("\ngsprt() syntax :\ngsprt(pixel_width,num_line,\n\"pic_var\",sprt_var)");
	picvar=getpuc;
	if(*argptr!=2) exit2("\ngsprt() syntax :\ngsprt(pixel_width,num_line,\n\"pic_var\",sprt_var)");
	sprt_dest=*(argptr+1);
	argptr+=2;
	varlist[sprt_dest]=(ans)sprtt;
	fpic=OpenFile(picvar);
	if(fpic==0) exit2("\ngsprt() syntax :\ngsprt(pixel_width,num_line,\n\"pic_var\",sprt_var)");

	switch(cval)		//Allow the user to use the []
	{
		case 1:
		case 8:
		byte_width_ilist[sprt_dest]=1;
		for(iii=0;iii<rval;iii++)
		{
			((char*)sprtt)[iii]=*((char*)((fpic->cptr)+6)+iii);
		}
		break;
		case 2:
		case 16:
		byte_width_ilist[sprt_dest]=2;
		for(iii=0;iii<rval;iii++)
		{
			((int*)sprtt)[iii]=*((int*)((fpic->cptr)+6)+iii);
		}
		break;
		case 4:
		case 32:
		byte_width_ilist[sprt_dest]=4;
		for(iii=0;iii<rval;iii++)
		{
			((long*)sprtt)[iii]=*((long*)((fpic->cptr)+6)+iii);
		}
		break;
		printf("\ngsprt() syntax :\ngsprt(pixel_width,num_line,\n\"pic_var\",sprt_var)"); ngetchx();
	}
	CloseOpenedFile(fpic);
	rsl(sprtt);	
}

ans savescr(void)
{
	unsigned char indexx;
	int ii;
	long *ptrrr,*lcdaddd;
	argptr++;
	indexx=getsl;
	lcdaddd=lcdad;	//conversion de type
	if(indexx>4) exit2("\nsavescr function,\nMaximum of 4 saved screens\nare allowed.\nOut of range : [0,3].");
	if(scr_copy[indexx]!=NULL)
	{
		free(scr_copy[indexx]);
	}

	scr_copy[indexx]=(ptrrr=malloc(LCD_SIZE));
	if(!ptrrr) exit2("\nNot enough memory\n for saving screen.");

	for(ii=0;ii<(LCD_SIZE/4);ii++)		//copy l'cran
	{
		ptrrr[ii]=lcdaddd[ii];
	}
	rsl(ptrrr);

}

ans loadscr(void)
{
	unsigned char indexx;
	int ii;
	long *ptrrr,*lcdaddd;
	argptr++;
	lcdaddd=lcdad;
	indexx=getsl;
	if(indexx>4) exit2("\nsavescr function,\nMaximum of 4 saved screens\nare allowed.\nOut of range : [0,3].");
	ptrrr=scr_copy[indexx];
	
	if(ptrrr!=NULL)
	{
			for(ii=0;ii<(LCD_SIZE/4);ii++)		//copy l'cran
		{
			lcdaddd[ii]=ptrrr[ii];
		}
	}
	rsl(ptrrr);
}




										//0				1				2				3				4				5				6				7				8				9
ans
 (*fonc[])(void)={		a		,	guchar,	gslvar,  gpvar,		LBL	,	GOTO	,	kwait	,		isz	,		dsz	,		a		, //0
										freeh ,tohandl,	exech	,	GOTOL	,	indir	,printf1,printf2,		a		,prints,		a		, //1
									svscroff,EDWHILE,	finish,		ifs	,strlenn,	printc,sprntf	,	chars	,	strct,	atoll	, //2
											a		,	guint	,		gint,		a		,		a		,	printd,printxy,	glong	,	gulong,	inter	, //3
										dline	,	dmline,setgmod,	sprt8	,	sprt16,	gstr	,		code,introff,intron ,		a		, //4
										setlcd,	dpix	,	gpix	,	sprt32,fillrec,	clrdrw,	rwky	,int1off,int1on ,	ifthen, //5
										getlcd,	WHILE	,		a		,		a		,scrrect,		a		,		a		,int5off,int5on	,	elsee	, //6
										gryon	,	gryoff,	ligh	,	dar		,		a		,	drwstr,setfontt,freet ,	sett	,	endif	, //7
									gotopos	,	pos		,	jsr 	,		rts	,	foncc	,		a		,		a		,		texp,		tval,		a		, //8
									scrleft	,scrrigh,scrup	,scrbot	,	lrol	,	rrol	,		a		,	 idlee,memcpyy,		a		, //9
									clscr		,	randd	,	gsprt,scrleft2,scrrigh2,scrup2,scrbot2,		a		,memmov,		a		, //10
											fope,	fclos	,	fptc	,	fgts	,	fgtc	,	fpts	,	fsek	,	gts		,		a		,		a		, //11
											nott,		a		,		neg	,		a		,		a		,		a		,	ftel	,		a		,		sto	,		a		, //12
											xorr,		orr	,		andd,		inf	,	infeq	,		eq	,	supeq	,		sup	,	noteq	,	addd	, //13
											a		,	sub		,		a		,	mul		,		a		,	divv	,		a		,		a		,		up	,	second, //14
											def	,	enddef,		a		,		f		,		arg	,		rtn	,	group	,		a		,	down	,	majj	, //15
										repeat,		a		,savescr,loadscr,		a		,		belm,	welm	,	lelm	,	left	,diamond, //16
											a		,	tios	,	toos	,	newstr,		a		,		wb	,		ww	,		wl	,	right	,alpha	, //17
									strcmpp	,strcpyy,		gkey,keydlay,keysped,		a		,		a		,		a		,		a		,		a		, //18
											pokb,	pokw	,	pokl	,		a		,		a		,		a		,		a		,		a		,		a		,		a		, //19
										pekb	,	pekw	,	pekl	,		a		,loadasm,		a		,		a		,		a		,		a		,		a		, //20
										newstr,		a		,		a		,llelem	,execasm,		a		,	nilist,	mklist,lusfunc,		a		, //21
											map	,	multi	,	two		,		a		,closeasm,		a	,		a		,		a		,		a		,	endtag, //22
											a		,		finl,		a		,	finish,	seqb	,	ctup	,	ctdown,		a		,		a		,		a		, //23
									debugon	,DEBUGOF,		a		,		a		,		seqw,		a		,		a		,		a	  ,execbas,		a		, //24
											nop	,	mallo	,		fre	,	mmset	,		seql,asm_cal,		a		,		a		,		a		,		a		}; //25




void exit2(unsigned char *str_error)
{
	int ii;
	clrscr();
	printf("\n%s",str_error);
	SetIntVec (AUTO_INT_5, OldInt5);
	ngetchx();
	free(argdep);
	if(sv_scr_on==1) {memcpy (LCD_MEM, screen_buffer, LCD_SIZE); free(screen_buffer);}
	OSInitKeyInitDelay(336);
	OSInitBetweenKeyDelay (48);
	for(ii=0;ii<4;ii++)			//free the save screen
	{
		if(scr_copy[ii]!=NULL) free(scr_copy[ii]);
	}
	exit(4);
}
void exit3(unsigned char *str_error)
{
	int ii;
	clrscr();
	printf("\n%s",str_error);
	SetIntVec (AUTO_INT_5, OldInt5);
	ngetchx();
	if(sv_scr_on==1) {memcpy (LCD_MEM, screen_buffer, LCD_SIZE); free(screen_buffer);}
	OSInitKeyInitDelay(336);
	OSInitBetweenKeyDelay (48);
	for(ii=0;ii<4;ii++)			//free the save screen
	{
		if(scr_copy[ii]!=NULL) free(scr_copy[ii]);
	}
	exit(4);
}
void disp_stack(void)
{
	ESI a;
	a=top_estack;
	printf("\nstack:\n");
	while(a!=bottom_estack) {printf("%c",*a); a--;}
	printf("\n");
	a=top_estack;
	while(a!=bottom_estack) {printf("%x ",*a); a--;}
}
// Main Function
void _main(void)
{
	ESI arg = top_estack;
	//SYM_ENTRY *src_entry;
	FILE *f;
	unsigned char *temp_str,srcname[20];
	unsigned int i;
	scr_rect.xy.x0=0;
	scr_rect.xy.y0=0;
	scr_rect.xy.x1=199;
	scr_rect.xy.y1=119;
	scr_copy[0]=NULL;	scr_copy[1]=NULL;	scr_copy[2]=NULL; scr_copy[3]=NULL;

	//Save screen automatically by default
	sv_scr_on=1;
	screen_buffer=malloc(LCD_SIZE);
	if(screen_buffer==NULL) exit2("Memory error in svscron()");
	memcpy (screen_buffer, LCD_MEM, LCD_SIZE);

	//For the function gkey()
	kbq = kbd_queue ();

	Counter=0;
	int5_allowed=1;
	OldInt5 = GetIntVec (AUTO_INT_5);
  SetIntVec (AUTO_INT_5, MyInt5);
  arg=top_estack;
  i_rtnf=0; inc=0;
  for(i=0;i<256;i++)	{byte_width_ilist[i]=4; varlist[i].sl=0;} //for llelem function, initialized to 4 by default for compatibility with the group() function
	i=0;
  for(i_intr=0;i_intr<20;i_intr++) //met a 0 toutes les interuptions
  {
  	argintr[i_intr]=0;
  	speedintr[i_intr]=0;
  }
  i_intr=0;
  nsubfonc=0; nswitch=0;
  if(GetArgType (arg) != STR_TAG) exit3("String arg expected\nSource file expected.");
  temp_str = GetStrnArg(arg);
  strcpy (srcname , temp_str);				//le nom du fichier header est affecte definitivement ici
  f=fopen(srcname,"r");
  srcsize=*(unsigned int*)(f->base);	//srcsize=size of data without first two bytes
  if(*((unsigned char*)(f->base)+srcsize+1)!=OTH_TAG) { exit2("OTHer prgm file expected");}
  argptr=malloc(srcsize);
  memcpy (argptr, (unsigned char*)(f->base)+2, srcsize);		
  fclose(f);
  //src_entry = DerefSym(SymFind(SYMSTR(srcname)));
  //if(src_entry && src_entry->name);
	//else exit2("fichier inexistant");
	//argptr=HToESI(src_entry->handle);
	//if(*argptr!=OTH_TAG) { exit2("OTHer prgm file expected");}
	//argptr=argptr-srcsize+1;
	argdep=argptr;
	gmode=1; nsubfonc=0; lcdad=LCD_MEM;
	init_bkm();
	OSDisableBreak(); //disable ON KEY breaking
	//OSSetSR (0x0700); //a enlever
	exec_none_stop();
	//exit2("Done");
}
